VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Demo:  How To Toggle An OptionButton"
   ClientHeight    =   3915
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7920
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3915
   ScaleWidth      =   7920
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdToggle 
      Caption         =   "Show Without Frames"
      Height          =   375
      Left            =   2640
      TabIndex        =   7
      Top             =   3360
      Width           =   2775
   End
   Begin VB.Frame Frame2 
      Caption         =   "  Sample Two  "
      Height          =   975
      Left            =   4200
      TabIndex        =   4
      Top             =   1320
      Width           =   3495
      Begin VB.OptionButton Option2 
         BackColor       =   &H00C0C0C0&
         Caption         =   "Option2"
         Enabled         =   0   'False
         ForeColor       =   &H00FFFFFF&
         Height          =   375
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   255
      End
      Begin VB.Label Label1 
         Caption         =   "      Sample Pseudo OptionButton"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   420
         Width           =   3135
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "  Sample One  "
      Height          =   1455
      Left            =   480
      TabIndex        =   1
      Top             =   1320
      Width           =   3255
      Begin VB.TextBox Text1 
         Height          =   375
         Left            =   360
         TabIndex        =   3
         Text            =   "Dummy SetFocus Object"
         Top             =   840
         Width           =   2535
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Sample Option Button"
         Height          =   375
         Left            =   360
         TabIndex        =   2
         Top             =   360
         Width           =   2295
      End
   End
   Begin VB.Label lblMsg 
      Alignment       =   2  'Center
      Caption         =   "Click either OptionButton to see the ""toggle"" effect."
      Height          =   255
      Left            =   360
      TabIndex        =   0
      Top             =   600
      Width           =   7335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-------------------------------------------------------------------------------------------
'Title: Make A Single OptionButton Toggle
'
'
'Copyright released to the public domain.  WF Matthews, 1 DEC 00
'
'Version
'   1.00    30 NOV 00   Original version.
'
'There is a printed copy of this in the Source Code book.
'-------------------------------------------------------------------------------------------
'
'
'SAMPLE1
'       Whenever the OptionButton gains focus, its state is changed to the opposite
'   of its current state. To produce the "toggle" effect, it's absolutely necessary
'   to move the focus to some other object on the form after changing its state.
'   Otherwise, there will not be a "toggle" action.
'       Unless the "other" control is visible, setting its "SetFocus" property is
'   useless, as focus never moves to a not-visible control.
'       If having to have another control visible on the form is a problem, use a TextBox
'    with its BorderStyle set to "None". Change the box's colors so that it blends into
'    the background of the form.  Finally, move the box to the back of the OptionButton.
'
'   Side Effects:
'       As implemented, the user can't "tab" to the OptionButton, because the
'   OptionButton's TabStop property is set to False to prevent tabbing to it.
'       If you want the control to be in the tab-sequence, remove the TabStop line of
'   code. However, note that when you tab to this OptionButton, it becomes unselected.
'       If you have other OptionButtons on the form, of course you'll have to have them
'   isolated from each other--use a frame with or without a border, to contain this option
'   button.
'
'
'SAMPLE2
'       Sample2 consists of an OptionButton, set with Enable=False, with its label
'    portion covered with yet another label. Clicking on the secondary label produces
'    the toggle action.
'       For proper effect, the secondary label should extend behind the OptionButton.  By
'    doing so, the user may click on the disabled OptionButton and effect a state-change.
'       The Enable=False effectively removes the control from the tab-sequence and it
'    prevents the user from bypassing the label-clicking and directly attempting, and
'    failing, to change the OptionButton's state.
'
'
'       If you have a need for an OptionButton to behave similar to a CheckBox, this may
'   be a useful work-around.
'
'Questions or comments welcomed:  wrsgp@bellsouth.net  (Bill Matthews)
'
'-------------------------------------------------------------------------------------------
Option Explicit
'SAMPLE 1
Private Sub Option1_GotFocus()
    On Error Resume Next
    Option1.Value = Not Option1.Value
    Text1.SetFocus
    Option1.TabStop = False
End Sub
'SAMPLE 2
Private Sub Label1_Click()
    On Error Resume Next
    Option2.Value = Not Option2.Value
End Sub
'Code below this point is only to effect a nice-looking demo.
Private Sub Form_Load()
    Me.Height = 4290
    Me.Width = 8010
    Me.Top = (Screen.Height - Me.Height) / 2
    Me.Left = (Screen.Width - Me.Width) / 2
End Sub
Private Sub cmdToggle_Click()
    Const NO_BORDER = 0
    Const A_BORDER = 1
    Dim BorderStyle

    On Error Resume Next
    Select Case Frame1.BorderStyle
        Case NO_BORDER: BorderStyle = A_BORDER
                        cmdToggle.Caption = "Show Without Frames"
        Case A_BORDER: BorderStyle = NO_BORDER
                        cmdToggle.Caption = "Show With Frames"
    End Select
    
    Frame1.BorderStyle = BorderStyle
    Frame2.BorderStyle = BorderStyle
    
End Sub
